From a4fdd2222a7703799b3ff93b46c5dbc9b096770f Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: May 22 2015 14:29:39 +0000
Subject: [PATCH 27/1001] Add caching around the API.


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 420c0a3..832c936 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -3,7 +3,7 @@ from hubs.widgets import stats
 from hubs.widgets import rules
 from hubs.widgets import sticky
 
-from hubs.widgets.base import AGPLv3
+from hubs.widgets.base import AGPLv3, smartcache
 
 registry = {
     'dummy': dummy,
@@ -52,9 +52,9 @@ def prepare_registry(registry):
         # Put source links in all API results
         module.data = AGPLv3(name)(module.data)
 
-        # TODO -- wrap a cache layer around the data functions
-        #         do this only if the module provides a cache invalidator
-        #         and warn in the logs if there's not one present?
+        # Wrap the data functions in a cache layer to be invalidated by fedmsg
+        module.data = smartcache(module)(module.data)
+
 
 validate_registry(registry)
 prepare_registry(registry)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 410bab5..9519079 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,9 +1,23 @@
 import collections
 import functools
 import hashlib
+import json
 
+import dogpile.cache
 import flask
-from six.moves import urllib_parse
+import six.moves.urllib_parse
+
+import fedmsg.config
+
+config = fedmsg.config.load_config()
+cache_defaults = {
+    "backend": "dogpile.cache.dbm",
+    "expiration_time": 1,  # Expire every 1 second, for development
+    "arguments": {"filename": "/var/tmp/fedora-hubs-cache.dbm"},
+}
+cache = dogpile.cache.make_region()
+cache.configure(**config.get('fedora-hubs.cache', cache_defaults))
+
 
 Argument = collections.namedtuple(
     'Argument', ('name', 'default', 'validator', 'help'))
@@ -32,6 +46,26 @@ def AGPLv3(name):
     return decorator
 
 
+def smartcache(module):
+    def decorator(func):
+        @wraps(func)
+        def inner(request, session, widget, *args, **kwargs):
+            key = cache_key_generator(module, args, kwargs)
+            creator = lambda: func(request, session, widget, *args, **kwargs)
+            return cache.get_or_create(key, creator)
+
+        return inner
+    return decorator
+
+
+def cache_key_generator(module, args, kwargs):
+    return "|".join([
+        module.__name__,
+        json.dumps(args),
+        json.dumps(kwargs),
+    ]).encode('utf-8')
+
+
 def wraps(original):
     @functools.wraps(original)
     def decorator(subsequent):
@@ -43,7 +77,7 @@ def wraps(original):
 
 def avatar(username, size=32):
     openid = 'http://%s.id.fedoraproject.org/' % username
-    query = urllib_parse.urlencode({'s': size, 'd': 'retro'})
+    query = six.moves.urllib_parse.urlencode({'s': size, 'd': 'retro'})
     hash = hashlib.sha256(openid.encode('utf-8')).hexdigest()
     template = "https://seccdn.libravatar.org/avatar/%s?%s"
     return template % (hash, query)
